/* usogres -- a replacement to postmaster tool distribute multiple postgres
 * Copyright (C) 2000-2002  HOSOKAWA Tetsuichi
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * $Id: SysLog.h,v 1.6 2001/06/29 01:32:51 hosokawa Exp $
 */

#ifndef WIN32

#ifdef HAVE_CONFIG_H
#  undef PACKAGE
#  undef VERSION
#  include "../config.h"
#endif
#include <stdio.h>
#include <syslog.h>
#include <stdarg.h>
#ifdef HAVE_STRING_H
#  include <string.h>
#endif

class SysLog {
	int level;
public:
	SysLog(const char* ident, int option = LOG_PID, int facility = LOG_DAEMON, int lvl = LOG_DEBUG);
	~SysLog() { closelog(); }

public:
	void set_level(int lvl) { level = lvl; }
	void printf(const char* format ...);
	void printf(int level, const char* format ...);
	void open(const char* ident, int option = LOG_PID, int facility = LOG_DAEMON, int lvl = LOG_DEBUG);
	void close();
};

#else	/* WIN32 */

#include <windows.h>
#include <stdio.h>
#include <assert.h>
#include <io.h>
class SysLog {
public:
	int level;
	SysLog(char* ident);
	~SysLog(){}

public:
	char* m_ident;
	void LogLevel(int loglevel);
	void printf(char *fmt, ...);
	void printf(WORD EventType, char *fmt, ...);

}; 
 
#endif
