/* usogres -- a replacement to postmaster tool distribute multiple postgres
 * Copyright (C) 2000-2002  HOSOKAWA Tetsuichi
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * $Id: debug.cc,v 1.2 2001/04/09 04:27:24 hosokawa Exp $
 */
#include <stdio.h>
#include <ctype.h>
#include "debug.h"

static void print_byte(int c)
{
	printf("%02x", c);
	if (c >= ' ' && c < 0x7e) {
		printf("%c", c);
	} else {
		printf(" ");
	}
}

void dump_buf(const char* buf, int size)
{
	if (size > 0) {
		int val;
		val = (int)((unsigned char)(buf[0]));
		printf("0000: ");
		print_byte(val);
		for (int i = 1; i < size; i++) {
			val = (int)((unsigned char)(buf[i]));
			printf(" ");
			print_byte(val);
			if (((i + 1) % 16) == 0) {
				printf("\n%04x:", i + 1);
			}
		}
		printf("\n");
	}
}
