/* usogres -- a replacement to postmaster tool distribute multiple postgres
 * Copyright (C) 2000-2002  HOSOKAWA Tetsuichi
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * $Id: exception.cc,v 1.2 2001/04/09 04:27:24 hosokawa Exp $
 */

#ifdef WIN32
#include <windows.h>
#endif

#include <stdio.h>
#include "exception.h"

UsogresException::UsogresException(const char* fn, int ln)
  : fname(fn),
	lno(ln),
	msg_buf(0)
{
}

UsogresException::~UsogresException()
{
	delete [] msg_buf;
}

const char* UsogresException::where()
{
	if (msg_buf == 0) {
		// 20 ... int max, 2 ... ::
		msg_buf = new char[strlen(fname) + strlen(what()) + 20 + 2 + 1];
		if (msg_buf == 0) {
			throw MemoryException(__FILE__, __LINE__);
		}
		sprintf(msg_buf, "%s:%d:%s", fname, lno, what());
	}
	return msg_buf;
}
