/* usogres -- a replacement to postmaster tool distribute multiple postgres
 * Copyright (C) 2000-2002  HOSOKAWA Tetsuichi
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * $Id: lock.h,v 1.3 2001/04/18 07:14:43 hosokawa Exp $
 */
#ifndef _USOGRES_LOCK_H_
#define _USOGRES_LOCK_H_

#include <stdarg.h>

class UsoLock {
	char* lock_path;
	int locksem;
	struct flock flock_struct;

public:
	UsoLock();
	~UsoLock();
	void lock();
	void unlock();
};

class UsoSem {
	int sem_fd[2];
	unsigned int sem_magic;
	static char* path;

#ifdef SEM_FAILED
#undef SEM_FAILED
#endif
	enum { SEM_MAGIC = 0x89674523 , SEM_FAILED = -1 };

public:
	UsoSem();
	~UsoSem();
	int open(int oflag = 0, ...);
	int close();
	int unlink();
	int post();
	int wait();
};

class UsoFork {
	UsoLock lock;
	int locking;

public:
	UsoFork();
	~UsoFork();
	void enter();
	void leave();
};

#endif
