/* usogres -- a replacement to postmaster tool distribute multiple postgres
 * Copyright (C) 2000-2002  HOSOKAWA Tetsuichi
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 * $Id: rc.h,v 1.4 2001/06/29 09:39:40 hosokawa Exp $
 */
#ifndef _USOGRESS_RC_H_
#define _USOGRESS_RC_H_

#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include <exception>
#include <string>

#ifdef WIN32
typedef std::basic_string<char> string;
#else
typedef basic_string<char> string;
#endif

class UsogresRC {
	string p_host;
	string p_hostorg;
	string p_hostcopy;
	int i_port;
	int i_portorg;
	int i_portcopy;
	string p_logdir;
	int i_max_process;
#ifdef WIN32
	int i_loglevel;
#endif

public:
	UsogresRC();

public:
	const string get_host();
	int get_port();
	const string get_hostorg();
	int get_portorg();
	const string get_hostcopy();
	int get_portcopy();
	const string get_logdir();
	int get_max_process();
#ifdef WIN32
	int get_loglevel();
#endif


public:
	int get_next_counter();

private:
	void set_defaults();
};

class Token {
	string str;
	int pointer;
private:
	void skip_white_space();
public:
	Token(const char* p);
	string get_next_token();
	void reset();
};

#endif
